<template>
  <button
    v-if="!drawer && !isMobile"
    class="drawer-btn mt-4 fixed max-[1380px]:!hidden"
    @click="drawer = true"
  >
    <svg-icon svg-name="left-arrow-fill" class="w-6 h-6" />
  </button>
  <div
    class="w-[320px] min-w-[320px] leftside-drawer p-4 relative z-10"
    :class="[
      isMobile ? '' : drawer ? 'left-to-right' : 'right-to-left',
      isMobile ? 'h-full' : 'h-[calc(100vh-76px)]',
      !props.isDrawerOpened && 'max-[1380px]:!hidden',
      {'!absolute': isFullIframe}
    ]"
  >
    <el-scrollbar>
      <div v-if="!isMobile" class="header-drawer">
        <button
          class="drawer-close-btn mb-[10px] max-[1380px]:!hidden"
          @click="onclose"
        >
          <svg-icon svg-name="left-arrow-fill" class="w-6 h-6" />
        </button>
      </div>
      <div
        class="overflow-auto"
        :class="isMobile ? 'h-[calc(100%+65px)]' : 'h-[calc(100%-30px)]'"
      >
        <!-- promotion/referral banner -->
        <div class="flex flex-col gap-2 pb-4 text-white">
          <nuxt-link
            v-if="isShowReferralPage"
            to="/referral-v2"
            class="relative"
          >
            <img
              v-lazy="
                getAssetImage(
                  'assets/theme/playful/images/sidebar_referral.png'
                )
              "
              class="object-contain h-full w-full rounded-lg"
              alt=""
            />
            <span class="absolute top-4 left-4 text-xl font-black capitalize">{{
              $t("referral")
            }}</span>
          </nuxt-link>
          <nuxt-link to="/promotion" class="relative" :id="ID.SIDE_BAR_MENU.promotion">
            <img
              v-lazy="
                getAssetImage(
                  'assets/theme/playful/images/sidebar_promotion.png'
                )
              "
              class="object-contain h-full w-full rounded-lg pointer-events-none"
              alt=""
            />
            <span class="absolute top-4 left-4 text-xl font-black capitalize pointer-events-none">{{
              $t("promotion")
            }}</span>
          </nuxt-link>
        </div>
        <!-- end promotion referral banner -->
        <!-- luckywheel banner -->
        <div
          v-if="findValidPromotion()"
          class="flex flex-col gap-2 pb-4 text-white"
        >
          <nuxt-link to="/?luckyWheel=true" class="relative">
            <img
              v-lazy="
                getAssetImage(
                  'assets/theme/playful/images/Sidebar_luckywheel.png'
                )
              "
              class="object-contain h-full w-full rounded-lg"
              alt=""
            />
            <span class="absolute top-4 left-4 text-xl font-black capitalize">{{
              $t("Luck Wheel")
            }}</span>
          </nuxt-link>
        </div>
        <!-- end luckywheel banner -->
        <!-- promotion list -->
        <div
          v-if="topFourPromotion && topFourPromotion.length"
          class="promotion-list pb-4"
        >
          <div class="flex px-2 gap-2 items-center pb-1">
            <svg-icon svg-name="icon-gift" class="w-6 h-6" />
            <span class="text-sm font-medium capitalize">{{
              $t("promotion")
            }}</span>
          </div>
          <div
            class="promotion-list-container p-2 flex flex-col gap-1 hover-item"
          >
            <nuxt-link
              v-for="(promotion, index) in topFourPromotion"
              :key="index"
              :to="`/promotion/${promotion.Id}`"
              class="flex gap-2 py-[13.5px] items-center px-4"
            >
              <img
                class="w-6 h-6"
                :src="
                  getAssetImage(
                    `assets/theme/playful/images/promotion/promotion-list-${promotion.PromotionTypeId}.svg`
                  )
                "
              />
              <span>{{ promotion.Title }}</span>
            </nuxt-link>
            <nuxt-link
              to="/promotion"
              class="bg-secondary h-10 text-white rounded-md flex items-center justify-center px-2"
              >{{ $t("learn_more") }}</nuxt-link
            >
          </div>
        </div>
        <!-- end promotion list -->
        <!-- game type list -->
        <div class="game-type-list pb-4">
          <div class="flex px-2 gap-2 items-center pb-1">
            <svg-icon svg-name="icon-game-type" class="w-6 h-6" />
            <span class="text-sm font-medium capitalize">{{
              $t("game_type")
            }}</span>
          </div>
          <div
            v-if="isMobile"
            class="game-type-list-container p-2 flex flex-col gap-1 hover-item"
          >
            <nuxt-link
              v-for="(gameType, index) in gameTypeList"
              :key="index"
              :to="`/games/${gameType}`"
              class="flex gap-2 py-[13.5px] items-center px-4"
              @click="onclose"
              :id="ID.GAME_TYPE_CATEGORY[gameType?.toUpperCase()]"
            >
              <img
                class="w-6 h-6 pointer-events-none"
                :src="
                  getAssetImage(
                    `assets/theme/playful/images/game-type/${gameType.replace(
                      ' ',
                      ''
                    )}.svg`
                  )
                "
              />
              <span class="pointer-events-none">{{ $t(gameType) }}</span>
            </nuxt-link>
          </div>
          <div
            v-else
            class="game-type-list-container p-2 flex flex-col gap-1 hover-item"
          >
            <nuxt-link
              v-for="(gameType, index) in gameTypeList"
              :key="index"
              :to="`/games/${gameType}`"
              class="flex gap-2 py-[13.5px] items-center px-4"
              :id="ID.GAME_TYPE_CATEGORY[gameType?.toUpperCase()]"
            >
              <img
                class="w-6 h-6 pointer-events-none"
                :src="
                  getAssetImage(
                    `assets/theme/playful/images/game-type/${gameType.replace(
                      ' ',
                      ''
                    )}.svg`
                  )
                "
              />
              <span class="pointer-events-none"> {{ $t(gameType) }}</span>
            </nuxt-link>
          </div>
        </div>
        <!-- end game type list -->
        <div v-if="isMobile" class="activity-center-list pb-4">
          <div class="flex px-2 gap-2 items-center pb-1">
            <svg-icon svg-name="activity-center" class="w-6 h-6" />
            <span class="text-sm font-medium capitalize">{{
              $t("Activity Center")
            }}</span>
          </div>
          <div
            v-if="gameTypeList.length"
            class="game-type-list-container p-2 flex flex-col gap-1 hover-item"
          >
            <nuxt-link
              to="/contact-us"
              class="flex gap-2 py-[13.5px] items-center"
            >
              <svg-icon svg-name="online-service" class="w-6 h-6" />
              <span>{{ $t("contact_us") }}</span>
            </nuxt-link>
          </div>
        </div>
      </div>
    </el-scrollbar>
  </div>
</template>

<script lang="ts" setup>
import { store } from "@/store";
import textHelper from "~~/utils/formatHelpers/textFormatHelper";
import { IPromotion } from "~~/models/promotion/promotion";

const props = defineProps({
  isDrawerOpened: {
    type: Boolean,
    default: false,
  },
  isFullIframe: {
    type: Boolean,
    default: false,
  },
});
const emits = defineEmits(["update:isDrawerOpened"]);
const drawer = ref(true);

const { getAssetImage } = commonHelper;
const { promotionListForDisplay } = usePromotion();
const isShowReferralPage = computed(() => store.state.IsShowReferralPage);
const topFourPromotion = computed(() =>
  promotionListForDisplay.value.slice(0, 4)
);

const gameTypeList = computed(
  () => store.state.gameTabProviderList.SeamlessGameGameTypeList
);
const isMobile = !useIsDesktop();
const onclose = () => {
  drawer.value = false;
  emits("update:isDrawerOpened", false);
  setTimeout(() => {
    const el = document.querySelector(".right-to-left");
    if (el) el.classList.add("hidden");
  }, 1000);
};
watch(
  () => props.isFullIframe,
  () => {
    drawer.value = !props.isFullIframe;
  },
  {
    immediate: true,
  }
);
const currency = computed(() =>
  store.state.currency ? store.state.currency : store.state.geography.Currency
);
const findValidPromotion = () => {
  const newDate = new Date();
  const formattedDate = Date.parse(
    textHelper.getGmtMinusFourDate(String(newDate), false, false)
  );
  const validDate = (promotion: IPromotion) =>
    Date.parse(promotion.StartDate) <= formattedDate &&
    formattedDate <= Date.parse(promotion.EndDate);
  const firstLuckyWheel = promotionListForDisplay.value.find(
    (item) =>
      item.PromotionTypeId === 10 &&
      validDate(item) &&
      item.Currency === currency.value
  );

  return firstLuckyWheel !== undefined;
};
</script>

<style lang="scss">
.lucky-wheel-dialog {
  right: 0;
}
@media only screen and (max-width: 960px) {
  .drawer-lg-screen {
    display: none;
  }
}
.header-drawer {
  width: 100%;
  position: sticky;
  top: 0;
  z-index: 2;
  background: linear-gradient(
      0deg,
      rgba(0, 0, 0, 0.25) 0%,
      rgba(0, 0, 0, 0.25) 100%
    ),
    var(--background5);
}
.leftside-drawer {
  background: linear-gradient(
      0deg,
      rgba(0, 0, 0, 0.25) 0%,
      rgba(0, 0, 0, 0.25) 100%
    ),
    var(--background5);
  &.left-to-right {
    animation: fadeLeftToRight 1s ease backwards;
  }
  &.right-to-left {
    animation: fadeRightToLeft 1s ease-in-out forwards;
  }
  .drawer-close-btn {
    padding: 4px;
    gap: 8px;
    height: 32px;
    width: 32px;
    border-radius: 8px;
    background: linear-gradient(
        0deg,
        rgba(255, 255, 255, 0.05) 0%,
        rgba(255, 255, 255, 0.05) 100%
      ),
      var(--background5);
  }

  .drawer-close-btn svg {
    fill: var(--text5, #fff);
    opacity: 0.5;
    transition: opacity 350ms ease;
  }
  .el-drawer__close-btn {
    display: none;
  }
  .el-drawer__header > :first-child {
    flex: unset;
  }
  .promotion-list-container,
  .game-type-list-container {
    border-radius: 8px;
    background: var(--background5);
  }
  .hover-item {
    :hover {
      border-radius: 8px;
      background: linear-gradient(
          0deg,
          rgba(255, 255, 255, 0.05) 0%,
          rgba(255, 255, 255, 0.05) 100%
        ),
        var(--background5, #1d2052);
    }
  }
}

@keyframes fadeLeftToRight {
  from {
    opacity: 0;
    transform: translateX(-100%);
  }
  to {
    opacity: 1;
    transform: translateX(0);
  }
}
@keyframes fadeRightToLeft {
  from {
    opacity: 1;
    transform: translateX(0);
  }
  to {
    opacity: 0;
    transform: translateX(-100%);
  }
}
</style>

<style scoped>
.drawer-btn {
  display: flex;
  padding: 4px;
  align-items: flex-start;
  gap: 8px;
  height: 32px;
  width: 32px;
  border-radius: 8px;
  /* position: fixed; */
  rotate: 180deg;
  background: linear-gradient(
      0deg,
      rgba(255, 255, 255, 0.05) 0%,
      rgba(255, 255, 255, 0.05) 100%
    ),
    var(--background5);
  /* top: 86px; */
  z-index: 25;
}

.drawer-btn svg {
  fill: var(--text5, #fff);
  opacity: 0.5;
  transition: opacity 350ms ease;
}

.drawer-btn:hover svg,
.drawer-btn:focus svg {
  opacity: 1;
}
</style>
